设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 107|回复: 3

[发布] xdrx_polyline_make与vla-addpolyline速度比较

[复制链接]

签到天数: 116 天

连续签到: 2 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

发表于 2017-7-24 12:13:55 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 brainstorm 于 2017-7-24 12:55 编辑

  1. (progn
  2. (setq plst nil)
  3. (setq plst (repeat 4
  4.              (setq plst (append plst (list (getpoint))))
  5.            )
  6. )
  7. (setq plst1 (apply 'append
  8.                    (append plst (list (car plst)))
  9.             )
  10. )
  11. (setq points
  12.        (vlax-make-safearray
  13.          vlax-vbdouble
  14.          (cons 0 (- (length plst1) 1))
  15.        )
  16. )
  17. (vlax-safearray-fill points plst1)
  18. )

  19. (setq ms
  20.        (vla-get-ModelSpace
  21.          (vla-get-ActiveDocument
  22.            (vlax-get-acad-object)
  23.          )
  24.        )
  25. )

  26. (defun C:tt2 ()
  27.   (setq ts (getvar "cdate"))
  28.   (repeat 5000
  29.     (xdrx_polyline_make plst t)
  30.   )
  31.   (setq te (getvar "cdate"))
  32.   (VL-PRIN1-TO-STRING (* 1e6 (- te ts)))
  33. )
  34. ;;;-------------------------------------------------------------------
  35. (defun C:tt5 ()
  36.   (setq ts (getvar "cdate"))
  37.   (repeat 5000
  38.     (vla-AddPolyline
  39.       ms
  40.       points
  41.     )
  42.   )
  43.   (setq te (getvar "cdate"))
  44.   (VL-PRIN1-TO-STRING (* 1e6 (- te ts)))
  45. )
tt2 "0.465661"  tt5 "1.59442",xdrx快很多
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

签到天数: 1027 天

连续签到: 17 天

[LV.10]以坛为家III

已领礼包: 40个

财富等级: 招财进宝

发表于 2017-7-24 13:55:02 | 显示全部楼层
xdrx_polyline_make 可以创建直线段的PL,也可以创建带弧线的PL
(xdrx_polyline_make pts bulges)
(xdrx_polyline_make pts)

另外,测试效率函数可以用 xd::quickbench
(xd::quickbench '( (c:tt2)
                           (c:tt5)
                        )
)
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 116 天

连续签到: 2 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

 楼主| 发表于 2017-7-28 16:57:40 来自手机 | 显示全部楼层
bulge 是点表么?给指点一下
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1027 天

连续签到: 17 天

[LV.10]以坛为家III

已领礼包: 40个

财富等级: 招财进宝

发表于 2017-7-28 17:06:22 | 显示全部楼层
本帖最后由 newer 于 2017-7-28 17:08 编辑

bulge 是 凸度, 是实数
QQ截图20170728170642.png

多段线数据定义里面,弧线段是用 起点 凸度 终点 定义的。起点和终点在点表参数里面,凸度值放凸度表里面

凸度表可以由(xdrx_getpropertyvalue pline "bulges") 得到,也可以遍历节点,用 xdrx_polyline_getbulgeat 单个 得到表。

下面代码在原位置复制一个多段线。

  1. (defun c:tt ()
  2.   (if (setq
  3.         e (car
  4.             (xdrx_entsel "\n拾取多段线<退出>:" '((0 . "LWPOLYLINE")))
  5.           )
  6.       )
  7.     (progn
  8.       (setq elst (xdrx_getpropertyvalue e "vertices" "bulges"))
  9.       (apply 'xdrx_polyline_make elst)
  10.       (xdrx_entity_SetPropertiesFrom (entlast) e)
  11.       (xdrx_prompt "\n原位置复制多段线完毕.")
  12.     )
  13.   )
  14.   (princ)
  15. )



论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2018-6-20 22:47 , Processed in 0.118063 second(s), 29 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

© 2001-2017 Comsenz Inc.

快速回复 返回顶部 返回列表